futhark-0.25.32: An optimising compiler for a functional, array-oriented language.

Safe Haskell | Safe-Inferred
Language | GHC2021

Futhark.Optimise.EntryPointMem

Description

We require that entry points return arrays with zero offset in row-major order. Futhark.Pass.ExplicitAllocations is conservative and inserts copies to ensure this is the case. After simplification, it may turn out that those copies are redundant. This pass removes them. It's a pretty simple pass, as it only has to look at the top level of entry points.

Synopsis

- entryPointMemGPU :: Pass GPUMem GPUMem
- entryPointMemMC :: Pass MCMem MCMem
- entryPointMemSeq :: Pass SeqMem SeqMem

# Documentation

entryPointMemGPU :: Pass GPUMem GPUMem Source #

The pass for GPU representation.

entryPointMemMC :: Pass MCMem MCMem Source #

The pass for MC representation.

entryPointMemSeq :: Pass SeqMem SeqMem Source #

The pass for Seq representation.